# coding: utf-8

"""
    LaunchDarkly REST API

    Build custom integrations with the LaunchDarkly REST API  # noqa: E501

    OpenAPI spec version: 5.4.0
    Contact: support@launchdarkly.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class ApprovalRequestFlagConfigCopyBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'description': 'str',
        'notify_member_ids': 'list[str]',
        'source': 'Source',
        'comment': 'str',
        'included_actions': 'list[CopyActions]',
        'excluded_actions': 'list[CopyActions]'
    }

    attribute_map = {
        'description': 'description',
        'notify_member_ids': 'notifyMemberIds',
        'source': 'source',
        'comment': 'comment',
        'included_actions': 'includedActions',
        'excluded_actions': 'excludedActions'
    }

    def __init__(self, description=None, notify_member_ids=None, source=None, comment=None, included_actions=None, excluded_actions=None):  # noqa: E501
        """ApprovalRequestFlagConfigCopyBody - a model defined in Swagger"""  # noqa: E501

        self._description = None
        self._notify_member_ids = None
        self._source = None
        self._comment = None
        self._included_actions = None
        self._excluded_actions = None
        self.discriminator = None

        self.description = description
        self.notify_member_ids = notify_member_ids
        self.source = source
        if comment is not None:
            self.comment = comment
        if included_actions is not None:
            self.included_actions = included_actions
        if excluded_actions is not None:
            self.excluded_actions = excluded_actions

    @property
    def description(self):
        """Gets the description of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501

        A name that describes the changes you would like to apply to a feature flag configuration  # noqa: E501

        :return: The description of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ApprovalRequestFlagConfigCopyBody.

        A name that describes the changes you would like to apply to a feature flag configuration  # noqa: E501

        :param description: The description of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501
        :type: str
        """
        if description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def notify_member_ids(self):
        """Gets the notify_member_ids of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501


        :return: The notify_member_ids of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501
        :rtype: list[str]
        """
        return self._notify_member_ids

    @notify_member_ids.setter
    def notify_member_ids(self, notify_member_ids):
        """Sets the notify_member_ids of this ApprovalRequestFlagConfigCopyBody.


        :param notify_member_ids: The notify_member_ids of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501
        :type: list[str]
        """
        if notify_member_ids is None:
            raise ValueError("Invalid value for `notify_member_ids`, must not be `None`")  # noqa: E501

        self._notify_member_ids = notify_member_ids

    @property
    def source(self):
        """Gets the source of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501


        :return: The source of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501
        :rtype: Source
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this ApprovalRequestFlagConfigCopyBody.


        :param source: The source of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501
        :type: Source
        """
        if source is None:
            raise ValueError("Invalid value for `source`, must not be `None`")  # noqa: E501

        self._source = source

    @property
    def comment(self):
        """Gets the comment of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501

        comment will be included in audit log item for change.  # noqa: E501

        :return: The comment of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this ApprovalRequestFlagConfigCopyBody.

        comment will be included in audit log item for change.  # noqa: E501

        :param comment: The comment of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501
        :type: str
        """

        self._comment = comment

    @property
    def included_actions(self):
        """Gets the included_actions of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501

        Define the parts of the flag configuration that will be copied.  # noqa: E501

        :return: The included_actions of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501
        :rtype: list[CopyActions]
        """
        return self._included_actions

    @included_actions.setter
    def included_actions(self, included_actions):
        """Sets the included_actions of this ApprovalRequestFlagConfigCopyBody.

        Define the parts of the flag configuration that will be copied.  # noqa: E501

        :param included_actions: The included_actions of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501
        :type: list[CopyActions]
        """

        self._included_actions = included_actions

    @property
    def excluded_actions(self):
        """Gets the excluded_actions of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501

        Define the parts of the flag configuration that will not be copied.  # noqa: E501

        :return: The excluded_actions of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501
        :rtype: list[CopyActions]
        """
        return self._excluded_actions

    @excluded_actions.setter
    def excluded_actions(self, excluded_actions):
        """Sets the excluded_actions of this ApprovalRequestFlagConfigCopyBody.

        Define the parts of the flag configuration that will not be copied.  # noqa: E501

        :param excluded_actions: The excluded_actions of this ApprovalRequestFlagConfigCopyBody.  # noqa: E501
        :type: list[CopyActions]
        """

        self._excluded_actions = excluded_actions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApprovalRequestFlagConfigCopyBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApprovalRequestFlagConfigCopyBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
